#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_SignInCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_SignInCFG> M_SignInCFG::msSingleton(nullptr);

int M_SignInCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_SignInCFGData* M_SignInCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_SignInCFGData>& M_SignInCFG::GetMapData()
{
	return mMapData;
}

void M_SignInCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_SignInCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_SignInCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mSignType = element->IntAttribute("SignType");
		{
			const char* FrontDisplay = element->Attribute("FrontDisplay");
			std::vector<std::string> vecFrontDisplay;
			boost::split(vecFrontDisplay, FrontDisplay, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecFrontDisplay.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecFrontDisplay[i].c_str(), &temp))
				{
					data.mFrontDisplay.push_back(temp);
				}
			}
		}
		{
			const char* FixedReward = element->Attribute("FixedReward");
			std::vector<std::string> vecFixedReward;
			boost::split(vecFixedReward, FixedReward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecFixedReward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecFixedReward[i].c_str(), &temp))
				{
					data.mFixedReward.push_back(temp);
				}
			}
		}
		{
			const char* ProbabilityReward = element->Attribute("ProbabilityReward");
			std::vector<std::string> vecProbabilityReward;
			boost::split(vecProbabilityReward, ProbabilityReward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecProbabilityReward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecProbabilityReward[i].c_str(), &temp))
				{
					data.mProbabilityReward.push_back(temp);
				}
			}
		}
		{
			const char* FirstRward = element->Attribute("FirstRward");
			std::vector<std::string> vecFirstRward;
			boost::split(vecFirstRward, FirstRward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecFirstRward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecFirstRward[i].c_str(), &temp))
				{
					data.mFirstRward.push_back(temp);
				}
			}
		}
		data.mBonusDoubles = element->IntAttribute("BonusDoubles");
		data.mVipLevel = element->IntAttribute("VipLevel");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_SignInCFG::Load()
{
	Load("../Config/M_SignInCFG.xml");
}

M_SignInCFG* M_SignInCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_SignInCFG());
	}
	return msSingleton.get();
}
